# -*- coding:Utf-8 -*-

import es
import usermsg
import re
import psyco
psyco.full()

info = es.AddonInfo()
info.name = "colormsglib"
info.version = "1.3"
info.author = "EmbouT"
info.url = "http://forums.mattie.info/cs/forums/viewtopic.php?t=24245"
info.description = "Fourni une méthode pour colorer les messages (rouge, bleu, gris, vert, vert clair, vert foncé et orange"

colorcode = {"#default": "\1",
             "#orange": "\1",
             "#lightgreen": "\3",
             "#red": "\3",
             "#blue": "\3",
             "#grey": "\3",
             "#team": "\3",
             "#green": "\4",
             "#darkgreen": "\5"}

ucolor = {1: 'lightgreen',
          4: 'grey',
          6: 'red',
          8: 'blue'}

icolor = {'red': 0,
          'blue': 0,
          'grey': -1,
          'lightgreen': 0}

team = {0: 'grey',
        1: 'grey',
        2: 'red',
        3: 'blue'}

iplayer = {0: [],
           1: [],
           2: [],
           3: []}


class ColorMsg():
    def __init__(self,msg):
        self.message = str(msg)
        self.colorname = "lightgreen"
        self.__formatmesssage()

    # private method
    def __formatmesssage(self):
        if not self.message.count('#team'):
            e = self.__check_ucolor()
            if e in (1,4,6,8):
                self.colorname = ucolor[e]
        else:
            self.colorname = "team"

        add = True
        for cc in colorcode:
            if self.message.startswith(cc):
                add = False
            self.message = re.sub(cc, colorcode[cc], self.message)
        if add:
            self.message = "\1" + self.message

    # private method
    def __check_ucolor(self):
        e = 1
        if self.message.count('#grey'):
            e += 3
        if self.message.count('#red'):
            e += 5
        if self.message.count('#blue'):
            e += 7
        return e

    # private method
    def __saytext(self, userid, index):
        es.usermsg('create', 'saytext', 'saytext')
        es.usermsg('write', 'byte', 'saytext', index)
        es.usermsg('write', 'string', 'saytext', self.message)
        es.usermsg('write', 'byte', 'saytext', 1)
        es.usermsg('send', 'saytext', userid)
        es.usermsg('delete', 'saytext')

    # public method
    def tell(self, player):
        try:
            userid = int(player)
            player = [userid]
        except TypeError:
            pass
        for userid in player:
            if es.exists('userid', userid):
                color = self.colorname
                if color == "team":
                    color = team[es.getplayerteam(userid)]
                index = icolor[color]
                self.__saytext(userid, index)
            else:
                es.dbgmsg(0, '[colormsglib] - %s is an invalid userid' % userid)

    # public method
    def msg(self):
        self.tell(es.getUseridList())

def setcolor(userindex, userteam):
    for t in team:
        if userindex in iplayer[t]:
            iplayer[t].remove(userindex)
        if icolor[team[t]] == userindex:
            if iplayer[t]:
                icolor[team[t]] = iplayer[t][len(iplayer[t])-1]
            else:
                icolor[team[t]] = 0
    iplayer[userteam].append(userindex)
    if not icolor[team[userteam]]:
        icolor[team[userteam]] = userindex

def initialise():
    if es.getplayercount():
        playerlist = es.createplayerlist()
        for userid in playerlist:
            userteam = playerlist[userid]['teamid']
            userindex = playerlist[userid]['index']
            setcolor(userindex, userteam)

def player_team(event_var):
    if not int(event_var['disconnect']):
        setcolor(int(event_var['es_userindex']), int(event_var['team']))

es.addons.registerForEvent(__import__(__name__), 'player_team', player_team)

initialise()


